#!/bin/bash

# @param String message - The message to log
readonly LOG_MESSAGE_COMMAND=$(basename "${0}")
logMessage()
{
	echo "$(date '+%a %b %e %T %Y') $LOG_MESSAGE_COMMAND: "${@} >> "${SCRIPT_LOG_FILE}"
}

updateFirewallRules()
{
	logMessage "Using PF";

	# enable pf
	pfctl -e

	read -d '' rules <<- EOF
		anchor "com.tunnelbear" {
			${RULES}
		}
	EOF

	echo "$rules" | pfctl -f -
}

teardown()
{
	logMessage $(pfctl -a 'com.tunnelbear' -F all)
}

status()
{
  pfctl -a "com.tunnelbear" -s rules
}

################# START HERE ####################

readonly SCRIPT_LOG_FILE="/var/log/tbeard/vigilant.log"

DEFAULT_INTERFACE=`netstat -nr |
grep -m1 default |
awk '{ if ($1 == "default") print $NF }'`
DEFAULT_IP=`ifconfig en0 |
sed -En 's/.*inet (addr:)?(([0-9]*\.){3}[0-9]*).*/\2/p'`
	
logMessage "Default Interface: $DEFAULT_INTERFACE"

if [ "$1" == "teardown" ]; then
  teardown
elif [ "$1" == "status" ]; then
  status
else
	RULES="$1"
  updateFirewallRules
fi
